您的位置:首页 > 编程语言 > C语言/C++

LeetCode-Best Time to Buy and Sell Stock III -解题报告

2015-07-02 12:33 573 查看
原题链接https://leetcode.com/problems/best-time-to-buy-and-sell-stock-iii/

Say you have an array for which the ith element is the price of a given stock on dayi.

Design an algorithm to find the maximum profit. You may complete at mosttwo transactions.

Note:

You may not engage in multiple transactions at the same time (ie, you must sell the stock before you buy again).

和版本1不同的地方在于交易次数变成了最多两次。

还是一样的老办法,不同的在于最大子段和,变成了最大m段子段和。

nums[i] = prices[i] - prices[i - 1], i >= 1

使用动态规划的方法,dp[k][i] = max(dp[k][i - 1],dp[k - 1][j]) + nums[i],  1<=k<=m, 1<=i<=n, k - 1 <= j <= i - 1

dp[k][i]表示前k段以i结尾的最大值。dp[k - 1][j]表示前k-1段以小于i结尾的最大值。

因为dp[k][i] 只和当前的dp[k][i-1]和上一次以小于i结尾的值有关,因此可以压缩空间。

使用cur[i]表示当前第k段以i结尾的最大值,pre[i]表示上一次以小于i结尾的最大值。

所以 程序可以描述成

for k  1 to m

max= 0

for i 1 to n

cur[i] = max(cur[i - 1], pre[i - 1]) + nums[i]

pre[i - 1] = max;

if(cur[i] > max)

max = cur[i];

class Solution {
public:
int maxProfit(vector<int>& prices) {
if (prices.size() < 2)return 0;
vector<int>cur(prices.size(), 0);
vector<int>pre(prices.size(), 0);
vector<int>nums(prices.size());
int Max;
for (int i = 1; i < prices.size(); ++i)
nums[i] = prices[i] - prices[i - 1];

for (int k = 1; k <= 2; ++k)
{
Max = 0;
for (int i = 1; i < prices.size(); ++i)
{
cur[i] = max(cur[i - 1], pre[i - 1]) + nums[i];
pre[i - 1] = Max;
if (cur[i] > pre[i - 1])
Max = cur[i];
}
}

return Max;
}
};


 
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  C++ leetcode algorithm